	.import	_main

        .export         _exit
        .import         initlib, donelib, copydata
        .import         push0, zerobss

	.include "zeropage.inc"
	.include "supervision.inc"

	.export	_sv_irq_timer_counter, _sv_irq_dma_counter
	.export	_sv_nmi_counter

.data

_sv_irq_dma_counter: .byte 0
_sv_irq_timer_counter: .byte 0
_sv_nmi_counter: .byte 0
	
.code

reset:
	jsr	zerobss

	; initialize data
	jsr	copydata

	lda	#>$2000
	stz	sp
	sta	sp+1
	jsr	initlib
	jsr	_main
_exit:	jmp	_exit

.proc irq
	pha
	lda	sv_irq_source
	and	#SV_IRQ_REQUEST_TIMER
	beq	not_timer
	lda	sv_timer_quit
	inc	_sv_irq_timer_counter
not_timer:
	lda	sv_irq_source
	and	#SV_IRQ_REQUEST_DMA
	beq	not_dma
	lda	sv_dma_quit
	inc	_sv_irq_dma_counter
not_dma:
	pla
	rti
.endproc

.proc nmi
	inc	_sv_nmi_counter
	rti
.endproc

; removing this segment gives only a warning	
        .segment "FFF0"
.proc reset32kcode
        lda     #(6<<5)
        sta     sv_bank
; now the 32kbyte image can reside in the top of 64kbyte, 128kbyte roms
        jmp     reset
.endproc
        .segment "VECTOR"
.word nmi,reset32kcode,irq
